//
//  NSString+IconFont.h
//  Gengmei
//
//  Created by lizhen on 2018/5/25.
//  Copyright © 2018年 更美互动信息科技有限公司. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSString (IconFont)

/**
 替换字符串中指定字体为iconfont

 @param oldString 要替换的字符串
 @param newString 替换后的字符串
 @param font 文字字体
 @param textColor 文字颜色
 @param lineSpace 行间距
 */
- (NSMutableAttributedString *)replaceString:(NSArray<NSString *> *)oldArray
                                 withStrings:(NSArray<NSString *> *)newArray
                                    font:(UIFont *)font
                                   textColor:(UIColor *)textColor
                                   lineSpace:(NSInteger)lineSpace;
@end

@interface NSString (IconFontFactory)

// 美购详情页中使用
- (NSMutableAttributedString *)welfareDetailNameWithFontSize:(NSInteger)size
                                                   textColor:(UIColor *)textColor;

// 其它各处的美购标题使用
- (NSMutableAttributedString *)welfareNameWithFontSize:(NSInteger)size
                                             textColor:(UIColor *)textColor
                                             lineSpace:(NSInteger)lineSpace;

- (NSMutableAttributedString *)customDetailNameWithFontSize:(UIFont *)font
                                             textColor:(UIColor *)textColor
                                             lineSpace:(NSInteger)lineSpace;

@end
